/*
    tstore - an archive format for archiving tar archives
    Copyright (C) 2004  Kasper Dupont

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    with permission from the author any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include "tstore.h"

uint8_t jump[210]= {
  1,10,9,8,7,6,5,4,3,2,1,2,1,4,3,2,1,2,1,4,3,2,1,6,5,4,3,2,1,2,
  1,6,5,4,3,2,1,4,3,2,1,2,1,4,3,2,1,6,5,4,3,2,1,6,5,4,3,2,1,2,
  1,6,5,4,3,2,1,4,3,2,1,2,1,6,5,4,3,2,1,4,3,2,1,6,5,4,3,2,1,8,
  7,6,5,4,3,2,1,4,3,2,1,2,1,4,3,2,1,2,1,4,3,2,1,8,7,6,5,4,3,2,
  1,6,5,4,3,2,1,4,3,2,1,6,5,4,3,2,1,2,1,4,3,2,1,6,5,4,3,2,1,2,
  1,6,5,4,3,2,1,6,5,4,3,2,1,4,3,2,1,2,1,4,3,2,1,6,5,4,3,2,1,2,
  1,6,5,4,3,2,1,4,3,2,1,2,1,4,3,2,1,2,1,10,9,8,7,6,5,4,3,2,1,2
};

uint64_t nextprime(uint64_t p)
{
  while(1) {
    uint64_t f;
    p+=jump[p%210];
    for (f=11;p%f;f=nextprime(f))
      if (f*f>p) return p;
  }
}

uint64_t prevprime(uint64_t p)
{
  while(1) {
    uint64_t f;
    p-=jump[(210-(p%210))%210];
    for (f=11;p%f;f=nextprime(f))
      if (f*f>p) return p;
  }
}
